diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-remote-station-manager.h ns-3.44/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.43/src/wifi/model/wifi-remote-station-manager.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-remote-station-manager.h	2025-03-09 16:55:49.803372600 -0700
@@ -9,23 +9,25 @@
 #ifndef WIFI_REMOTE_STATION_MANAGER_H
 #define WIFI_REMOTE_STATION_MANAGER_H
 
+#include "extended-capabilities.h"
 #include "qos-utils.h"
 #include "wifi-mode.h"
 #include "wifi-remote-station-info.h"
 #include "wifi-utils.h"
 
+#include "ns3/common-info-basic-mle.h"
 #include "ns3/data-rate.h"
 #include "ns3/eht-capabilities.h"
 #include "ns3/he-6ghz-band-capabilities.h"
 #include "ns3/he-capabilities.h"
 #include "ns3/ht-capabilities.h"
 #include "ns3/mac48-address.h"
-#include "ns3/multi-link-element.h"
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
 #include "ns3/vht-capabilities.h"
 
 #include <array>
+#include <list>
 #include <memory>
 #include <optional>
 #include <unordered_map>
@@ -38,6 +40,7 @@
 class WifiMacHeader;
 class Packet;
 class WifiMpdu;
+class WifiPsdu;
 class WifiTxVector;
 class WifiTxParameters;
 
@@ -45,7 +48,7 @@
 struct RxSignalInfo;
 
 /**
- * \brief hold per-remote-station state.
+ * @brief hold per-remote-station state.
  *
  * The state in this class is used to keep track
  * of association status if we are in an infrastructure
@@ -57,7 +60,10 @@
  */
 struct WifiRemoteStation
 {
-    virtual ~WifiRemoteStation(){};
+    virtual ~WifiRemoteStation()
+    {
+    }
+
     WifiRemoteStationState* m_state; //!< Remote station state
     std::pair<dBm_u, Time>
         m_rssiAndUpdateTimePair; //!< RSSI of the most recent packet received from
@@ -99,7 +105,9 @@
     bool m_dsssSupported;              //!< Flag if DSSS is supported by the remote station
     bool m_erpOfdmSupported;           //!< Flag if ERP OFDM is supported by the remote station
     bool m_ofdmSupported;              //!< Flag if OFDM is supported by the remote station
-    Ptr<const HtCapabilities> m_htCapabilities;   //!< remote station HT capabilities
+    Ptr<const HtCapabilities> m_htCapabilities; //!< remote station HT capabilities
+    Ptr<const ExtendedCapabilities>
+        m_extendedCapabilities;                   //!< remote station extended capabilities
     Ptr<const VhtCapabilities> m_vhtCapabilities; //!< remote station VHT capabilities
     Ptr<const HeCapabilities> m_heCapabilities;   //!< remote station HE capabilities
     Ptr<const He6GhzBandCapabilities>
@@ -120,8 +128,8 @@
 };
 
 /**
- * \ingroup wifi
- * \brief hold a list of per-remote-station state.
+ * @ingroup wifi
+ * @brief hold a list of per-remote-station state.
  *
  * \sa ns3::WifiRemoteStation.
  */
@@ -129,8 +137,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -158,168 +166,190 @@
      * Set up PHY associated with this device since it is the object that
      * knows the full set of transmit rates that are supported.
      *
-     * \param phy the PHY of this device
+     * @param phy the PHY of this device
      */
     virtual void SetupPhy(const Ptr<WifiPhy> phy);
     /**
      * Set up MAC associated with this device since it is the object that
      * knows the full set of timing parameters (e.g. IFS).
      *
-     * \param mac the MAC of this device
+     * @param mac the MAC of this device
      */
     virtual void SetupMac(const Ptr<WifiMac> mac);
 
     /**
+     * Set the ID of the link this Remote Station Manager is associated with.
+     *
+     * @param linkId the ID of the link this Remote Station Manager is associated with
+     */
+    void SetLinkId(uint8_t linkId);
+
+    /**
      * Assign a fixed random variable stream number to the random variables
      * used by this model.  Return the number of streams (possibly zero) that
      * have been assigned.
      *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
+     * @param stream first stream index to use
+     * @return the number of stream indices assigned by this model
      */
     virtual int64_t AssignStreams(int64_t stream);
 
     /**
      * Sets the maximum STA short retry count (SSRC).
      *
-     * \param maxSsrc the maximum SSRC
+     * @param maxSsrc the maximum SSRC
      */
     void SetMaxSsrc(uint32_t maxSsrc);
     /**
      * Sets the maximum STA long retry count (SLRC).
      *
-     * \param maxSlrc the maximum SLRC
+     * @param maxSlrc the maximum SLRC
      */
     void SetMaxSlrc(uint32_t maxSlrc);
     /**
      * Sets the RTS threshold.
      *
-     * \param threshold the RTS threshold
+     * @param threshold the RTS threshold
      */
     void SetRtsCtsThreshold(uint32_t threshold);
 
     /**
      * Return the fragmentation threshold.
      *
-     * \return the fragmentation threshold
+     * @return the fragmentation threshold
      */
     uint32_t GetFragmentationThreshold() const;
     /**
      * Sets a fragmentation threshold. The method calls a private method
      * DoSetFragmentationThreshold that checks the validity of the value given.
      *
-     * \param threshold the fragmentation threshold
+     * @param threshold the fragmentation threshold
      */
     void SetFragmentationThreshold(uint32_t threshold);
 
     /**
      * Record the AID of a remote station. Should only be called by APs.
      *
-     * \param remoteAddress the MAC address of the remote station
-     * \param aid the Association ID
+     * @param remoteAddress the MAC address of the remote station
+     * @param aid the Association ID
      */
     void SetAssociationId(Mac48Address remoteAddress, uint16_t aid);
     /**
      * Records QoS support of the remote station.
      *
-     * \param from the address of the station being recorded
-     * \param qosSupported whether the station supports QoS
+     * @param from the address of the station being recorded
+     * @param qosSupported whether the station supports QoS
      */
     void SetQosSupport(Mac48Address from, bool qosSupported);
     /**
-     * \param from the address of the station being recorded
-     * \param emlsrEnabled whether EMLSR mode is enabled for the station on this link
+     * @param from the address of the station being recorded
+     * @param emlsrEnabled whether EMLSR mode is enabled for the station on this link
      */
     void SetEmlsrEnabled(const Mac48Address& from, bool emlsrEnabled);
     /**
      * Records HT capabilities of the remote station.
      *
-     * \param from the address of the station being recorded
-     * \param htCapabilities the HT capabilities of the station
+     * @param from the address of the station being recorded
+     * @param htCapabilities the HT capabilities of the station
      */
-    void AddStationHtCapabilities(Mac48Address from, HtCapabilities htCapabilities);
+    void AddStationHtCapabilities(Mac48Address from, const HtCapabilities& htCapabilities);
+    /**
+     * Records extended capabilities of the remote station.
+     *
+     * @param from the address of the station being recorded
+     * @param extendedCapabilities the extended capabilities of the station
+     */
+    void AddStationExtendedCapabilities(Mac48Address from,
+                                        const ExtendedCapabilities& extendedCapabilities);
     /**
      * Records VHT capabilities of the remote station.
      *
-     * \param from the address of the station being recorded
-     * \param vhtCapabilities the VHT capabilities of the station
+     * @param from the address of the station being recorded
+     * @param vhtCapabilities the VHT capabilities of the station
      */
-    void AddStationVhtCapabilities(Mac48Address from, VhtCapabilities vhtCapabilities);
+    void AddStationVhtCapabilities(Mac48Address from, const VhtCapabilities& vhtCapabilities);
     /**
      * Records HE capabilities of the remote station.
      *
-     * \param from the address of the station being recorded
-     * \param heCapabilities the HE capabilities of the station
+     * @param from the address of the station being recorded
+     * @param heCapabilities the HE capabilities of the station
      */
-    void AddStationHeCapabilities(Mac48Address from, HeCapabilities heCapabilities);
+    void AddStationHeCapabilities(Mac48Address from, const HeCapabilities& heCapabilities);
     /**
      * Records HE 6 GHz Band Capabilities of a remote station
      *
-     * \param from the address of the remote station
-     * \param he6GhzCapabilities the HE 6 GHz Band Capabilities of the remote station
+     * @param from the address of the remote station
+     * @param he6GhzCapabilities the HE 6 GHz Band Capabilities of the remote station
      */
     void AddStationHe6GhzCapabilities(const Mac48Address& from,
                                       const He6GhzBandCapabilities& he6GhzCapabilities);
     /**
      * Records EHT capabilities of the remote station.
      *
-     * \param from the address of the station being recorded
-     * \param ehtCapabilities the EHT capabilities of the station
+     * @param from the address of the station being recorded
+     * @param ehtCapabilities the EHT capabilities of the station
      */
-    void AddStationEhtCapabilities(Mac48Address from, EhtCapabilities ehtCapabilities);
+    void AddStationEhtCapabilities(Mac48Address from, const EhtCapabilities& ehtCapabilities);
     /**
      * Records the Common Info field advertised by the given remote station in a Multi-Link
      * Element. It includes the MLD address of the remote station.
      *
-     * \param from the address of the station being recorded
-     * \param mleCommonInfo the MLE Common Info advertised by the station
+     * @param from the address of the station being recorded
+     * @param mleCommonInfo the MLE Common Info advertised by the station
      */
     void AddStationMleCommonInfo(Mac48Address from,
                                  const std::shared_ptr<CommonInfoBasicMle>& mleCommonInfo);
     /**
      * Return the HT capabilities sent by the remote station.
      *
-     * \param from the address of the remote station
-     * \return the HT capabilities sent by the remote station
+     * @param from the address of the remote station
+     * @return the HT capabilities sent by the remote station
      */
     Ptr<const HtCapabilities> GetStationHtCapabilities(Mac48Address from);
     /**
+     * Return the extended capabilities sent by the remote station.
+     *
+     * @param from the address of the remote station
+     * @return the extended capabilities sent by the remote station
+     */
+    Ptr<const ExtendedCapabilities> GetStationExtendedCapabilities(const Mac48Address& from);
+    /**
      * Return the VHT capabilities sent by the remote station.
      *
-     * \param from the address of the remote station
-     * \return the VHT capabilities sent by the remote station
+     * @param from the address of the remote station
+     * @return the VHT capabilities sent by the remote station
      */
     Ptr<const VhtCapabilities> GetStationVhtCapabilities(Mac48Address from);
     /**
      * Return the HE capabilities sent by the remote station.
      *
-     * \param from the address of the remote station
-     * \return the HE capabilities sent by the remote station
+     * @param from the address of the remote station
+     * @return the HE capabilities sent by the remote station
      */
     Ptr<const HeCapabilities> GetStationHeCapabilities(Mac48Address from);
     /**
      * Return the HE 6 GHz Band Capabilities sent by a remote station.
      *
-     * \param from the address of the remote station
-     * \return the HE 6 GHz Band capabilities sent by the remote station
+     * @param from the address of the remote station
+     * @return the HE 6 GHz Band capabilities sent by the remote station
      */
     Ptr<const He6GhzBandCapabilities> GetStationHe6GhzCapabilities(const Mac48Address& from) const;
     /**
      * Return the EHT capabilities sent by the remote station.
      *
-     * \param from the address of the remote station
-     * \return the EHT capabilities sent by the remote station
+     * @param from the address of the remote station
+     * @return the EHT capabilities sent by the remote station
      */
     Ptr<const EhtCapabilities> GetStationEhtCapabilities(Mac48Address from);
     /**
-     * \param from the (MLD or link) address of the remote non-AP MLD
-     * \return the EML Capabilities advertised by the remote non-AP MLD
+     * @param from the (MLD or link) address of the remote non-AP MLD
+     * @return the EML Capabilities advertised by the remote non-AP MLD
      */
     std::optional<std::reference_wrapper<CommonInfoBasicMle::EmlCapabilities>>
     GetStationEmlCapabilities(const Mac48Address& from);
     /**
-     * \param from the (MLD or link) address of the remote non-AP MLD
-     * \return the MLD Capabilities advertised by the remote non-AP MLD
+     * @param from the (MLD or link) address of the remote non-AP MLD
+     * @return the MLD Capabilities advertised by the remote non-AP MLD
      */
     std::optional<std::reference_wrapper<CommonInfoBasicMle::MldCapabilities>>
     GetStationMldCapabilities(const Mac48Address& from);
@@ -328,7 +358,7 @@
      * associated with. Note that this means that this function returns false if this is a
      * 6 GHz link.
      *
-     * \return true if HT capability support is enabled, false otherwise
+     * @return true if HT capability support is enabled, false otherwise
      */
     bool GetHtSupported() const;
     /**
@@ -336,88 +366,88 @@
      * associated with. Note that this means that this function returns false if this is a
      * 2.4 or 6 GHz link.
      *
-     * \return true if VHT capability support is enabled, false otherwise
+     * @return true if VHT capability support is enabled, false otherwise
      */
     bool GetVhtSupported() const;
     /**
      * Return whether the device has HE capability support enabled.
      *
-     * \return true if HE capability support is enabled, false otherwise
+     * @return true if HE capability support is enabled, false otherwise
      */
     bool GetHeSupported() const;
     /**
      * Return whether the device has EHT capability support enabled.
      *
-     * \return true if EHT capability support is enabled, false otherwise
+     * @return true if EHT capability support is enabled, false otherwise
      */
     bool GetEhtSupported() const;
     /**
      * Return whether the device has LDPC support enabled.
      *
-     * \return true if LDPC support is enabled, false otherwise
+     * @return true if LDPC support is enabled, false otherwise
      */
     bool GetLdpcSupported() const;
     /**
      * Return whether the device has SGI support enabled.
      *
-     * \return true if SGI support is enabled, false otherwise
+     * @return true if SGI support is enabled, false otherwise
      */
     bool GetShortGuardIntervalSupported() const;
     /**
-     * Return the supported HE guard interval duration.
+     * Return the shortest supported HE guard interval duration.
      *
-     * \return the supported HE guard interval duration
+     * @return the shortest supported HE guard interval duration
      */
     Time GetGuardInterval() const;
     /**
      * Enable or disable protection for non-ERP stations.
      *
-     * \param enable enable or disable protection for non-ERP stations
+     * @param enable enable or disable protection for non-ERP stations
      */
     void SetUseNonErpProtection(bool enable);
     /**
      * Return whether the device supports protection of non-ERP stations.
      *
-     * \return true if protection for non-ERP stations is enabled,
+     * @return true if protection for non-ERP stations is enabled,
      *         false otherwise
      */
     bool GetUseNonErpProtection() const;
     /**
      * Enable or disable protection for non-HT stations.
      *
-     * \param enable enable or disable protection for non-HT stations
+     * @param enable enable or disable protection for non-HT stations
      */
     void SetUseNonHtProtection(bool enable);
     /**
      * Return whether the device supports protection of non-HT stations.
      *
-     * \return true if protection for non-HT stations is enabled,
+     * @return true if protection for non-HT stations is enabled,
      *         false otherwise
      */
     bool GetUseNonHtProtection() const;
     /**
      * Enable or disable short PHY preambles.
      *
-     * \param enable enable or disable short PHY preambles
+     * @param enable enable or disable short PHY preambles
      */
     void SetShortPreambleEnabled(bool enable);
     /**
      * Return whether the device uses short PHY preambles.
      *
-     * \return true if short PHY preambles are enabled,
+     * @return true if short PHY preambles are enabled,
      *         false otherwise
      */
     bool GetShortPreambleEnabled() const;
     /**
      * Enable or disable short slot time.
      *
-     * \param enable enable or disable short slot time
+     * @param enable enable or disable short slot time
      */
     void SetShortSlotTimeEnabled(bool enable);
     /**
      * Return whether the device uses short slot time.
      *
-     * \return true if short slot time is enabled,
+     * @return true if short slot time is enabled,
      *         false otherwise
      */
     bool GetShortSlotTimeEnabled() const;
@@ -432,250 +462,259 @@
      * BSSBasicRateSet of the associated AP and which are supported locally.
      * Invoked in an AP to configure the BSSBasicRateSet.
      *
-     * \param mode the WifiMode to be added to the basic mode set
+     * @param mode the WifiMode to be added to the basic mode set
      */
     void AddBasicMode(WifiMode mode);
     /**
      * Return the default transmission mode.
      *
-     * \return WifiMode the default transmission mode
+     * @return WifiMode the default transmission mode
      */
     WifiMode GetDefaultMode() const;
     /**
      * Return the number of basic modes we support.
      *
-     * \return the number of basic modes we support
+     * @return the number of basic modes we support
      */
     uint8_t GetNBasicModes() const;
     /**
      * Return a basic mode from the set of basic modes.
      *
-     * \param i index of the basic mode in the basic mode set
+     * @param i index of the basic mode in the basic mode set
      *
-     * \return the basic mode at the given index
+     * @return the basic mode at the given index
      */
     WifiMode GetBasicMode(uint8_t i) const;
     /**
      * Return the number of non-ERP basic modes we support.
      *
-     * \return the number of basic modes we support
+     * @return the number of basic modes we support
      */
     uint32_t GetNNonErpBasicModes() const;
     /**
      * Return a basic mode from the set of basic modes that is not an ERP mode.
      *
-     * \param i index of the basic mode in the basic mode set
+     * @param i index of the basic mode in the basic mode set
      *
-     * \return the basic mode at the given index
+     * @return the basic mode at the given index
      */
     WifiMode GetNonErpBasicMode(uint8_t i) const;
     /**
      * Return whether the station supports LDPC or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if LDPC is supported by the station,
+     * @return true if LDPC is supported by the station,
      *         false otherwise
      */
     bool GetLdpcSupported(Mac48Address address) const;
     /**
      * Return whether the station supports short PHY preamble or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if short PHY preamble is supported by the station,
+     * @return true if short PHY preamble is supported by the station,
      *         false otherwise
      */
     bool GetShortPreambleSupported(Mac48Address address) const;
     /**
      * Return whether the station supports short ERP slot time or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if short ERP slot time is supported by the station,
+     * @return true if short ERP slot time is supported by the station,
      *         false otherwise
      */
     bool GetShortSlotTimeSupported(Mac48Address address) const;
     /**
      * Return whether the given station is QoS capable.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if the station has QoS capabilities,
+     * @return true if the station has QoS capabilities,
      *         false otherwise
      */
     bool GetQosSupported(Mac48Address address) const;
     /**
      * Get the AID of a remote station. Should only be called by APs.
      *
-     * \param remoteAddress the MAC address of the remote station
-     * \return the Association ID if the station is associated, SU_STA_ID otherwise
+     * @param remoteAddress the MAC address of the remote station
+     * @return the Association ID if the station is associated, SU_STA_ID otherwise
      */
     uint16_t GetAssociationId(Mac48Address remoteAddress) const;
     /**
      * Add a given Modulation and Coding Scheme (MCS) index to
      * the set of basic MCS.
      *
-     * \param mcs the WifiMode to be added to the basic MCS set
+     * @param mcs the WifiMode to be added to the basic MCS set
      */
     void AddBasicMcs(WifiMode mcs);
     /**
      * Return the default Modulation and Coding Scheme (MCS) index.
      *
-     * \return the default WifiMode
+     * @return the default WifiMode
      */
     WifiMode GetDefaultMcs() const;
     /**
      * Return the default MCS to use to transmit frames to the given station.
      *
-     * \param st the given station
-     * \return the default MCS to use to transmit frames to the given station
+     * @param st the given station
+     * @return the default MCS to use to transmit frames to the given station
      */
     WifiMode GetDefaultModeForSta(const WifiRemoteStation* st) const;
     /**
      * Return the number of basic MCS index.
      *
-     * \return the number of basic MCS index
+     * @return the number of basic MCS index
      */
     uint8_t GetNBasicMcs() const;
     /**
      * Return the MCS at the given <i>list</i> index.
      *
-     * \param i the position in the list
+     * @param i the position in the list
      *
-     * \return the basic MCS at the given list index
+     * @return the basic MCS at the given list index
      */
     WifiMode GetBasicMcs(uint8_t i) const;
     /**
      * Record the MCS index supported by the station.
      *
-     * \param address the address of the station
-     * \param mcs the WifiMode supported by the station
+     * @param address the address of the station
+     * @param mcs the WifiMode supported by the station
      */
     void AddSupportedMcs(Mac48Address address, WifiMode mcs);
     /**
      * Return the channel width supported by the station.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return the channel width supported by the station
+     * @return the channel width supported by the station
      */
     MHz_u GetChannelWidthSupported(Mac48Address address) const;
     /**
      * Return whether the station supports HT/VHT short guard interval.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if the station supports HT/VHT short guard interval,
+     * @return true if the station supports HT/VHT short guard interval,
      *         false otherwise
      */
     bool GetShortGuardIntervalSupported(Mac48Address address) const;
     /**
      * Return the number of spatial streams supported by the station.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return the number of spatial streams supported by the station
+     * @return the number of spatial streams supported by the station
      */
     uint8_t GetNumberOfSupportedStreams(Mac48Address address) const;
     /**
      * Return the number of MCS supported by the station.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return the number of MCS supported by the station
+     * @return the number of MCS supported by the station
      */
     uint8_t GetNMcsSupported(Mac48Address address) const;
     /**
      * Return whether the station supports DSSS or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if DSSS is supported by the station,
+     * @return true if DSSS is supported by the station,
      *         false otherwise
      */
     bool GetDsssSupported(const Mac48Address& address) const;
     /**
      * Return whether the station supports ERP OFDM or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if ERP OFDM is supported by the station,
+     * @return true if ERP OFDM is supported by the station,
      *         false otherwise
      */
     bool GetErpOfdmSupported(const Mac48Address& address) const;
     /**
      * Return whether the station supports OFDM or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if OFDM is supported by the station,
+     * @return true if OFDM is supported by the station,
      *         false otherwise
      */
     bool GetOfdmSupported(const Mac48Address& address) const;
     /**
      * Return whether the station supports HT or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if HT is supported by the station,
+     * @return true if HT is supported by the station,
      *         false otherwise
      */
     bool GetHtSupported(Mac48Address address) const;
     /**
      * Return whether the station supports VHT or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if VHT is supported by the station,
+     * @return true if VHT is supported by the station,
      *         false otherwise
      */
     bool GetVhtSupported(Mac48Address address) const;
     /**
      * Return whether the station supports HE or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if HE is supported by the station,
+     * @return true if HE is supported by the station,
      *         false otherwise
      */
     bool GetHeSupported(Mac48Address address) const;
     /**
      * Return whether the station supports EHT or not.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return true if EHT is supported by the station,
+     * @return true if EHT is supported by the station,
      *         false otherwise
      */
     bool GetEhtSupported(Mac48Address address) const;
     /**
-     * \param address the (MLD or link) address of the non-AP MLD
-     * \return whether the non-AP MLD supports EMLSR
+     * @param address the (MLD or link) address of the non-AP MLD
+     * @return whether the non-AP MLD supports EMLSR
      */
     bool GetEmlsrSupported(const Mac48Address& address) const;
     /**
-     * \param address the (MLD or link) address of the non-AP MLD
-     * \return whether EMLSR mode is enabled for the non-AP MLD on this link
+     * @param address the (MLD or link) address of the non-AP MLD
+     * @return whether EMLSR mode is enabled for the non-AP MLD on this link
      */
     bool GetEmlsrEnabled(const Mac48Address& address) const;
 
     /**
      * Return a mode for non-unicast packets.
      *
-     * \return WifiMode for non-unicast packets
+     * @return WifiMode for non-unicast packets
      */
     WifiMode GetNonUnicastMode() const;
 
     /**
+     * Return the TXVECTOR to use for a groupcast packet.
+     *
+     * @param header the MAC header of the groupcast packet
+     * @param allowedWidth the allowed width in MHz to send this packet
+     * @return the TXVECTOR to use to send the groupcast packet
+     */
+    WifiTxVector GetGroupcastTxVector(const WifiMacHeader& header, MHz_u allowedWidth);
+
+    /**
      * Invoked in a STA or AP to store the set of
      * modes supported by a destination which is
      * also supported locally.
      * The set of supported modes includes
      * the BSSBasicRateSet.
      *
-     * \param address the address of the station being recorded
-     * \param mode the WifiMode supports by the station
+     * @param address the address of the station being recorded
+     * @param mode the WifiMode supports by the station
      */
     void AddSupportedMode(Mac48Address address, WifiMode mode);
     /**
